﻿package  {
	import fl.transitions.easing.None;
	import fl.transitions.easing.Regular;
	import fl.transitions.Transition;
	import fl.transitions.Tween;
	import flash.display.DisplayObject;
	import flash.display.MovieClip;
	import flash.events.Event;
	import flash.events.MouseEvent;
	import flash.filters.BitmapFilterQuality;
	import flash.filters.GlowFilter;
	import flash.utils.getQualifiedClassName;
	public class Background extends Actor {
		var rocks:Array = [];
		var bugs:Array = [];
		var water:Array = [];
		
		var weedsHeight:Number = 0;
		var weedsScaleY:Number = 0;
		
		public function Background() {
			var i:int;
			for (i = 0; i < numChildren; i++) {
				var ch:MovieClip = getChildAt(i) as MovieClip;
				if (ch) {
					var className:String = getQualifiedClassName(ch).toLowerCase();
					if (className.search("rock") >= 0)
						rocks.push(ch);
					else if (className.search("bug") >= 0)
						bugs.push(ch);
					else if (className.search("water") >= 0)
						water.push(ch);
				}
			}
			
			for (i = 0; i < rocks.length; i++) {
				//(rocks[i] as DisplayObject).filters[0].alpha = 0;
				rocks[i].addEventListener(MouseEvent.ROLL_OVER, RockRollOver, false, 0, true);
				rocks[i].addEventListener(MouseEvent.ROLL_OUT, SomethingRollOut, false, 0, true);
			}
			for (i = 0; i < bugs.length; i++) {
				//(bugs[i] as DisplayObject).filters[0].alpha = 0;
				bugs[i].addEventListener(MouseEvent.ROLL_OVER, BugRollOver, false, 0, true);
				bugs[i].addEventListener(MouseEvent.ROLL_OUT, SomethingRollOut, false, 0, true);
			}
			for (i = 0; i < water.length; i++) {
				//(water[i] as DisplayObject).filters[0].alpha = 0;
				//water[i].filters = [new GlowFilter(0x00ffff, 1, 6, 6, 3, BitmapFilterQuality.HIGH)];
				water[i].addEventListener(MouseEvent.ROLL_OVER, WaterRollOver, false, 0, true);
				water[i].addEventListener(MouseEvent.ROLL_OUT, SomethingRollOut, false, 0, true);
			}
			
			weeds.addEventListener(MouseEvent.ROLL_OVER, WeedRollOver, false, 0, true);
			pumpkin.addEventListener(MouseEvent.ROLL_OVER, PumpkinRollOver, false, 0, true);
			pumpkin.addEventListener(MouseEvent.ROLL_OUT, SomethingRollOut, false, 0, true);
			weeds.scaleY = 0;
			y = T.halfHeight;
			AddToLayer(g.layerBack);
		}
		
		public function RockRollOver(e:MouseEvent):void {
			g.popup.Show(9);
		}
		
		public function BugRollOver(e:MouseEvent):void {
			g.popup.Show(10);
		}
		
		public function WaterRollOver(e:MouseEvent):void {
			g.popup.Show(11);
		}
		
		public function SomethingRollOut(e:MouseEvent):void {
			g.popup.Hide();
		}
		
		public function WeedRollOver(e:MouseEvent):void {
			g.popup.Show(12);
		}
		
		public function PumpkinRollOver(e:MouseEvent):void {
			g.popup.Show(13);
		}
		
		public function GrowWeeds():void {
			// compute the new height, then set scale back to original
			var scaleAmount:Number = 0.75;
			var oldScaleY:Number = weeds.scaleY;
			weeds.scaleY = weedsScaleY + scaleAmount;
			weedsHeight = weeds.height;
			weeds.scaleY = oldScaleY;
			// doing it this way guarantees GrowWeeds() called repeatedly grows to the
			// same size despite how quickly the function was called
			weedsScaleY = weeds.scaleY + scaleAmount;
			Misc.NewTween(new Tween(weeds, "scaleY", Regular.easeOut, weeds.scaleY, weedsScaleY, 0.5, true));
			g.hud.WeedsHaveGrown();
			g.CheckLeafs(); // called elsewhere too??
		}
		
		public function TrimWeeds():void {
			weedsHeight = 0;
			weedsScaleY = 0;
			Misc.NewTween(new Tween(weeds, "scaleY", Regular.easeOut, weeds.scaleY, 0, 0.5, true));
		}
	}
}





























