﻿package  {
	import flash.display.MovieClip;
	import flash.display.Sprite;
	import flash.events.Event;
	import flash.events.MouseEvent;
	public class Game extends MovieClip {
		var time:Number = 0;
		var keys:Keys = null;
		
		var bg:Background = null;
		var hud:Hud = null;
		var roots:Roots = null;
		var res:Array = [0, 0, 0, 0, 0, 0];
		var resGainedToday:Array = [0, 0, 0, 0, 0, 0];
		var pumpkin:Pumpkin = null;
		var popup:Popup = null;
		var fullScreen:FullScreen = null;
		var day:int = 1;
		var plantNodes:Array = null;
		var leafs:Array = null;
		var fameCost:int = 5;
		
		// cam
		var camx:Number = 0;
		var camt:Number = 0;
		var cam:Number = 0;
		var camy0:Number = 0;
		var camy1:Number = 0;
		public static const camSurface:Number = T.height * 0.45;
		public static const camLevel:Number = 0;
		public static const camBeneath:Number = -T.height * 0.45;
		public static const camPans:Array = [
			camLevel,
			camBeneath,
			camLevel,
			camSurface];
		
		var sorted:Array = null;
		var layerBack:Sprite = null;
		var layerSorted:Sprite = null;
		var layerUnsorted:Sprite = null;
		var layerTop:Sprite = null;
		var layerUI:Sprite = null;
		var weight_kg:int = 0;
		var weight_lbs:int = 0;
		
		public function Game() {
			Actor.g = this;
			addEventListener(Event.ADDED_TO_STAGE, Added, false, 0, true);
		}
		
		public function Added(e:Event):void {
			var i:int;
			
			removeEventListener(Event.ADDED_TO_STAGE, Added, false);
			
			sorted = new Array;
			layerBack = new Sprite;
			layerSorted = new Sprite;
			layerUnsorted = new Sprite;
			layerTop = new Sprite;
			layerUI = new Sprite;
			addChild(layerBack);
			addChild(layerSorted);
			addChild(layerUnsorted);
			addChild(layerTop);
			addChild(layerUI);
			
			res[T.res_vitamin.index] = 40;
			res[T.res_water.index] = 40;
			res[T.res_sun.index] = 40;
			res[T.res_co2.index] = 40;
			res[T.res_fame.index] = 0;
			res[T.res_sugar.index] = 0;
			if (T.dev_lotsOfResources) {
				for (i = 0; i < res.length; i++)
					res[i] = 999;
			}
			
			keys = new Keys(stage);
			addEventListener(Event.ENTER_FRAME, Tick, false, 0, true);
			// init stuff here!
			bg = new Background;
			fullScreen = new FullScreen;
			fullScreen.visible = false;
			plantNodes = new Array;
			leafs = new Array;
			hud = new Hud;
			pumpkin = bg.pumpkin;
			roots = new Roots;
			new PlantNode(T.halfWidth, T.ground - 15).Activate();
			popup = new Popup;
			cam = camLevel;
			SetCam(cam, true);
			day = 0;
			//GoodMorning();
			new Logo;			
			AA.ChangeMusic(AA.track1);
		}
		
		public function Infect(_percent:Number):void {
			var i:int;
			var healthyLeafs:Array = new Array;
			for (i = 0; i < leafs.length; i++) {
				if (!leafs[i].leafBug.visible)
					healthyLeafs.push(leafs[i]);
			}
			var count:int = Math.floor(healthyLeafs.length * Misc.Saturate(_percent));
			if (count > 0) {
				for (i = 0; i < count; i++) {
					if (healthyLeafs.length > 0) {
						var leaf:Leaf = Misc.RandomArrayObj(healthyLeafs, true) as Leaf;
						leaf.leafBug.visible = true;
					}
				}
				hud.PestsHaveGrown();
			}
		}
		
		public function Pesticide():void {
			var i:int;
			for (i = 0; i < leafs.length; i++) {
				leafs[i].leafBug.visible = false;
			}
		}
		
		public function CheckLeafs():void {
			var i:int;
			for (i = 0; i < leafs.length; i++) {
				if (leafs[i].y >= T.ground - bg.weedsHeight)
					leafs[i].Toggle(false);
				else
					leafs[i].Toggle(true);
			}
		}
		
		public function EndDay():void {
			hud.endDay.visible = false;
			fullScreen.visible = true;
			CountAllResTodayAndCreatePeffs();
			new Clipboard();
		}
		
		public function GoodMorning(_growWeeds:Boolean = false, _infect:Boolean = false):void {
			var i:int;
			for (i = 0; i < resGainedToday.length; i++) {
				resGainedToday[i] = 0;
			}
			
			if (_growWeeds)
				bg.GrowWeeds();
			if (_infect) {
				var t:Number = Misc.Saturate(day / 15.0);
				Infect(Misc.Lerp(0.10, 0.25, t));
			}
			
			day++;
			hud.endDay.visible = true;
			hud.Update();
		}
		
		public function CountAllResTodayAndCreatePeffs():void {
			var i:int;
			var count:int;
			for (i = 0; i < roots.allNodes.numChildren; i++) {
				var r:RootNode = roots.allNodes.getChildAt(i) as RootNode;
				if (!r.terminal) {
					GiveResAll(T.giveRoot);
				}
			}
			for (i = 0; i < leafs.length; i++) {
				var leaf:Leaf = leafs[i];
				if (leaf.state && !leaf.leafBug.visible) {
					GiveResAll(T.giveLeaf);
				}
			}
			
			var inter:Array = null;
			inter = roots.GetIntersections(bg.water);
			for (i = 0; i < inter.length; i++) {
				GiveResAll(T.giveWaterSource);
			}
			
			inter = roots.GetIntersections(bg.bugs);
			for (i = 0; i < inter.length; i++) {
				GiveResAll(T.giveBugSource);
			}
		}
		
		public function SortActors():void {
			var i:int;
			sorted.sort(SortByDepth);
			while (layerSorted.numChildren > 0)
				layerSorted.removeChildAt(0);
			for (i = 0; i < sorted.length; i++)
				layerSorted.addChild(sorted[i]);
		}
		
		public function SortByDepth(_a:Actor, _b:Actor):int {
			if (_a.depthValue + _a.depthOffset > _b.depthValue + _b.depthOffset)
				return 1;
			return -1;
		}
		
		public function SetCam(_y:Number, _instant:Boolean):void {
			_y = Misc.Clamp(_y, -1650, 1650);
			
			if (_instant) {
				camt = 1;
				camy0 = _y;
				camy1 = _y;
			}
			else {
				camt = 0;
				camy0 = cam;
				camy1 = _y;
			}
		}
		
		public function CanAffordAll(_cost:Array):Boolean {
			var i:int;
			for (i = 0; i < T.NumRes; i++) {
				if (!CanAfford(_cost[i], T.res[i])) {
					return false;
				}
			}
			return true;
		}
		
		public function SpendAll(_cost:Object):void {
			var i:int;
			for (i = 0; i < T.NumRes; i++) {
				SpendRes(_cost[i], T.res[i]);
			}
		}
		
		public function CanAfford(_amount:int, _res:Object):Boolean {
			return res[_res.index] >= _amount;
		}
		
		public function GiveRes(_amount:int, _res:Object):int {
			res[_res.index] += _amount;
			resGainedToday[_res.index] += _amount;
			hud.Update();
			return res[_res.index];
		}
		
		public function GiveResAll(_amount:Array):void {
			var i:int;
			for (i = 0; i < _amount.length; i++) {
				GiveRes(_amount[i], T.res[i]);
			}
		}
		
		public function SpendRes(_amount:int, _res:Object):int {
			res[_res.index] -= _amount;
			hud.Update();
			return res[_res.index];
		}
		
		public function SetFocus():void {
			stage.focus = stage;
		}
		
		public function Tick(e:Event):void {
			keys.Tick();
			time += T.dt;
			AA.Tick(T.dt);
			dispatchEvent(new GEvent(GEvent.Tick));
			SortActors();
			//Actor.g.SetFocus();
			
			camt += T.dt * 2.0;
			if (camt > 1.0)
				camt = 1.0;
			cam = Misc.Lerp(camy0, camy1, Math.pow(camt, 0.75));
			
			layerBack.x = camx;
			layerSorted.x = camx;
			layerUnsorted.x = camx;
			layerTop.x = camx;
			
			layerBack.y = cam;
			layerSorted.y = cam;
			layerUnsorted.y = cam;
			layerTop.y = cam;
		}
	}
}


























