﻿package  {
	import fl.transitions.easing.None;
	import fl.transitions.easing.Regular;
	import fl.transitions.Transition;
	import fl.transitions.Tween;
	import flash.display.MovieClip;
	import flash.display.Sprite;
	import flash.events.MouseEvent;
	public class PlantNode extends Actor {
		var childNodes:Array = null;
		var lines:Sprite = new Sprite;
		
		public function PlantNode(_x:Number, _y:Number) {
			gotoAndStop(2);
			x = _x;
			y = _y;
			buttonMode = true;
			addEventListener(MouseEvent.ROLL_OVER, OnRollOver, false, 0, true);
			addEventListener(MouseEvent.ROLL_OUT, OnRollOut, false, 0, true);
			addEventListener(MouseEvent.CLICK, OnClick, false, 0, true);
			AddToLayer(g.layerUnsorted);
			AddToContainer(g.plantNodes);
			
			Misc.NewTween(new Tween(this, "scaleX", Regular.easeOut, 0.1, 1.0, 0.2, true));
			Misc.NewTween(new Tween(this, "scaleY", Regular.easeOut, 0.1, 1.0, 0.2, true));
			
			lines = new Sprite;
			g.layerBack.addChild(lines);
		}
		
		public function OnRollOver(e:MouseEvent):void {
			g.popup.Show(1);
		}
		
		public function OnRollOut(e:MouseEvent):void {
			g.popup.Hide();
		}
		
		public function OnClick(e:MouseEvent):void {
			if (g.CanAffordAll(T.costLeaf)) {
				AA.Play(AA.leafs1);
				Activate();
				g.SpendAll(T.costLeaf);
			}
			else {
				g.hud.CannotAfford();
			}
		}
		
		public function Activate():void {
			gotoAndStop(1);
			buttonMode = false;
			mouseEnabled = false;
			childNodes = new Array;
			var i:int;
			for (i = 0; i < 2; i++) {
				var ang:Number = Misc.Random(0, Math.PI * 2.0);
				var len:Number = Misc.Random(60, 90);
				var newx:Number = x + Math.cos(ang) * len;
				var newy:Number = y + Math.sin(ang) * len;
				if (newy > T.ground)
					newy = T.ground;
				
				var t:Number = Misc.Random(0.25, 0.75);
				new Leaf(Misc.Lerp(x, newx, t), Misc.Lerp(y, newy, t));
				
				var child:PlantNode = new PlantNode(newx, newy);
				childNodes.push(child);
			}
			UpdateLines();
		}
		
		public function UpdateLines():void {
			var i:int;
			lines.graphics.clear();
			lines.graphics.lineStyle(4, 0x4C7013, 1);
			if (childNodes && childNodes.length > 0) {
				for (i = 0; i < childNodes.length; i++) {
					lines.graphics.moveTo(x, y);
					lines.graphics.lineTo(childNodes[i].x, childNodes[i].y);
				}
			}
		}
	}
}


























