package {
	import fl.transitions.easing.None;
	import fl.transitions.easing.Regular;
	import fl.transitions.Transition;
	import fl.transitions.Tween;
	import flash.display.MovieClip;
	import flash.display.Sprite;
	import flash.events.MouseEvent;
	import flash.geom.Point;
	public class RootNode extends MovieClip {
		var terminal:Boolean = false;
		var roots:Roots = null;
		var rootParent:RootNode = null;
		var children:Array = [];
		var activated:Boolean = false;
		var linesInactive:Sprite = new Sprite;
		var linesActive:Sprite = new Sprite;
		
		public function RootNode(_roots:Roots) {
			gotoAndStop(2);
			roots = _roots;
			linesInactive = new Sprite;
			linesActive = new Sprite;
			roots.allLinesInactive.addChild(linesInactive);
			roots.allLinesActive.addChild(linesActive);
			roots.allNodes.addChild(this);
			roots.Step();
			
			Misc.NewTween(new Tween(this, "scaleX", Regular.easeOut, 0.1, 1.0, 0.2, true));
			Misc.NewTween(new Tween(this, "scaleY", Regular.easeOut, 0.1, 1.0, 0.2, true));
			
			mouseEnabled = true;
			buttonMode = true;
			addEventListener(MouseEvent.ROLL_OVER, RollOver, false, 0, true);
			addEventListener(MouseEvent.ROLL_OUT, RollOut, false, 0, true);
			addEventListener(MouseEvent.CLICK, Click, false, 0, true);
		}
		
		public function CheckRocks():Boolean {
			var i:int;
			var onScreen:Point = localToGlobal(new Point);
			for (i = 0; i < Actor.g.bg.rocks.length; i++) {
				//if ((Actor.g.bg.rocks[i] as MovieClip).hitTestPoint(x, y, true)) {
				if ((Actor.g.bg.rocks[i] as MovieClip).hitTestPoint(onScreen.x, onScreen.y, true)) {
					terminal = true;
					gotoAndStop(3);
					mouseEnabled = false;
					buttonMode = false;
					return true;
				}
			}
			return false;
		}
		
		public function RollOver(e:MouseEvent):void {
			if (!activated) {
				Actor.g.popup.Show(2);
			}
		}
		
		public function RollOut(e:MouseEvent):void {
			Actor.g.popup.Hide();
		}
		
		public function Click(e:MouseEvent):void {
			if (!activated) {
				if (Actor.g.CanAffordAll(T.costRoot)) {
					AA.Play(AA.leafs2);
					Activate();
					Actor.g.SpendAll(T.costRoot);
				}
				else {
					Actor.g.hud.CannotAfford();
				}
			}
		}
		
		public function Activate():void {
			activated = true;
			buttonMode = false;
			mouseEnabled = false;
			gotoAndStop(1);
			CreateChildren();
			UpdateLines();
			if (rootParent)
				rootParent.UpdateLines();
		}
		
		public function CreateChildren():void {
			var node:RootNode = null;
			var ang:Number = Misc.Random(Math.PI * 0.1, Math.PI * 0.4);
			var len:Number = Misc.Random(40, 60);
			node = new RootNode(roots);
			node.x = x + Math.cos(ang) * len;
			node.y = y + Math.sin(ang) * len;
			node.rootParent = this;
			node.CheckRocks();
			children.push(node);
			
			ang = Misc.Random(Math.PI * 0.6, Math.PI * 0.9);
			node = new RootNode(roots);
			node.x = x + Math.cos(ang) * len;
			node.y = y + Math.sin(ang) * len;
			node.rootParent = this;
			node.CheckRocks();
			children.push(node);
		}
		
		public function UpdateLines():void {
			linesInactive.graphics.clear();
			//linesInactive.graphics.lineStyle(2, 0x6D4E16, 1);
			linesActive.graphics.clear();
			//linesActive.graphics.lineStyle(4, 0x09AFD7, 1);
			linesInactive.graphics.lineStyle(4, 0x6D4413, 1);
			linesActive.graphics.lineStyle(4, 0x6D4413, 1);
			var i:int;
			for (i = 0; i < children.length; i++) {
				var line:Sprite = linesInactive;
				if (children[i].activated)
					line = linesActive;
				line.graphics.moveTo(x, y);
				line.graphics.lineTo(children[i].x, children[i].y);
			}
		}
	}
}






























