package {
	import flash.display.DisplayObject;
	import flash.display.MovieClip;
	import flash.display.Sprite;
	import flash.filters.BitmapFilterQuality;
	import flash.filters.GlowFilter;
	import flash.geom.Point;
	public class Roots extends Actor {
		var nodes:Array = [];
		var allLinesInactive:Sprite = new Sprite;
		var allLinesActive:Sprite = new Sprite;
		var allNodes:Sprite = new Sprite;
		
		public function Roots() {
			addChild(allLinesInactive);
			addChild(allLinesActive);
			addChild(allNodes);
			var initial:RootNode = NewRoot(null, true);
			initial.Activate();
			AddEventListener(GEvent.Tick, Tick);
			AddToLayer(g.layerUnsorted);
		}
		
		public function NewRoot(_parent:RootNode, _activated:Boolean, _ang:Number = 0):RootNode {
			var node:RootNode = new RootNode(this);
			node.rootParent = _parent;
			if (!_parent) {
				node.x = T.halfWidth;
				node.y = T.ground;
			}
			return node;
		}
		
		public function Intersect(_mc:MovieClip):Boolean {
			var i:int;
			var j:int;
			var k:int;
			for (i = 0; i < allNodes.numChildren; i++) {
				var node:RootNode = allNodes.getChildAt(i) as RootNode;
				if (node) {// && node.activated) {
				var nodePos:Point = node.localToGlobal(new Point);
					if (_mc.hitTestPoint(nodePos.x, nodePos.y, true))
						return true;
				}
				for (j = 0; j < node.children.length; j++) {
					var other:RootNode = node.children[j] as RootNode;
					if (other) {// && other.activated) {
						// skip 0, b/c it is node.xy
						for (k = 1; k < 20; k++) {
							var t:Number = k / 20.0;
							var newx:Number = Misc.Lerp(node.x, other.x, t);
							var newy:Number = Misc.Lerp(node.y, other.y, t);
							var newPos:Point = g.layerUnsorted.localToGlobal(new Point(newx, newy));
							if (_mc.hitTestPoint(newPos.x, newPos.y, true)) {
								return true;
							}
						}
					}
				}
			}
			return false;
		}
		
		public function GetIntersections(_arr:Array):Array {
			var i:int;
			var j:int;
			var intersections:Array = [];
			for (i = 0; i < _arr.length; i++) {
				var mc:MovieClip = _arr[i];
				if (mc) {
					if (Intersect(mc)) {
						intersections.push(mc);
					}
				}
			}
			return intersections;
		}
		
		public function Step():void {
			var i:int;
			var inter:Array = GetIntersections(g.bg.water);
			//trace("water: " + inter.length);
			for (i = 0; i < inter.length; i++) {
				if (!inter[i].filters || !inter[i].filters.length <= 1)
					inter[i].filters = [new GlowFilter(0x00ffff, 1, 6, 6, 3, BitmapFilterQuality.HIGH)];
			}
			
			inter = GetIntersections(g.bg.bugs);
			//trace("bugs: " + inter.length);
			for (i = 0; i < inter.length; i++) {
				if (!inter[i].filters || !inter[i].filters.length <= 1)
					inter[i].filters = [new GlowFilter(0x00ffff, 1, 6, 6, 3, BitmapFilterQuality.HIGH)];
			}
			
			inter = GetIntersections(g.bg.rocks);
			//trace("rocks: " + inter.length);
		}
		
		public function Tick(e:GEvent):void {
			
		}
	}
}


















